{ Coktel Vision ITK/STK file extractor v1.0 }
{ (c) 1999 by John Doe                      }
{ mail me:    john_doe@talknet.de           }
{ Public Domain Souce Code                  }

uses crt,nTools;

type PEntry=^FEntry;
     FEntry=record
      size,pos:longint;
      name:string[13];
     end;

var d:array[1..10000]of PEntry;
    f:file;
    count,l:word;
    cname,outdir:string;
begin
 writeln('Coktel Vision ITK/STK file extractor 1.0     (c) 1999 by John Doe');
 if(paramCount=0)then begin
  writeln('use: itk [ITK/STK file] (output dir)');
  writeln('if output directory is not given all files are');
  writeln('extracted into the current directory.');
  halt;
 end;
 cname:=paramStr(1);
 if(paramCount=2)then outdir:=paramStr(2) else outdir:='.\';
 if(outdir[length(outdir)]<>'\')then outdir:=outdir+'\';
 FileMode:=0;
 assign(f,cname); reset(f,1);

 { Read directory }
 blockread(f,count,2);
 writeln(count,' files');
 for l:=1 to count do begin
  getMem(d[l],sizeof(FEntry));
  with d[l]^ do begin
   name[0]:=#12;
   blockread(f,name[1],13);
   blockread(f,size,4);
   blockread(f,pos,4);
   seek(f,filepos(f)+1);
   writeln(name);
  end;
 end;

 { Extract files }
 for l:=1 to count do begin
  with d[l]^ do begin
   write('Extracting ',name,' (',size,' bytes)...');
   seek(f,pos);
   CopyFileTo(f,outdir+name,size);
  end;
  freeMem(d[l],sizeof(FEntry));
 end;
 close(f);
end.